/*******************************************************************************
 *                                                                             *
 * Player_Mini_Mp3, This library provides a quite complete function for        *
 * Player mini mp3 module.                                                     *
 *                                                                             *
 * This file is part of the Player_Mini_Mp3 library.                           *
 *                                                                             *
 ******************************************************************************/

/*
 *	Description:	connect Player Mini by SoftwareSerial, this code is test on Uno
 **Wire: **Board : Uno
		*Pin10 - player TX; 
		*Pin11 - player RX;
		*pin3  - player BUSY

 *	Note: the mp3 files must put into mp3 folder in your tf card 
 */
#include <SoftwareSerial.h>
#include <Player_Mini_Mp3.h>

SoftwareSerial mySerial(10, 11); // RX, TX

void setup () {
  Serial.begin (9600);
  mySerial.begin (9600);
  mp3_set_serial (mySerial);	//set softwareSerial for Player-mini mp3 module 
  delay(1);  //wait 1ms for mp3 module to set volume
  mp3_set_volume (15);          // value 0~30
}

void loop () {   
  boolean play_state = digitalRead(3);
  if(play_state == HIGH){
    mp3_next ();
  }
}


